Subject: Re: git on MacOSX and files with decomposed utf-8 file names

From: Theodore Tso <[email-masked]>
Date: Mon, 21 Jan 2008 16:18:02 -0500

On Mon, Jan 21, 2008 at 03:58:03PM -0500, Kevin Ballard wrote:
> You're making the huge assumption that the HFS+ normalization algorithms 
> will change. As the technote states:
>
> "Platform algorithms tend to evolve with the Unicode standard. The HFS Plus 
> algorithms cannot evolve because such evolution would invalidate existing 
> HFS Plus volumes."

Great, so even worse.  Does the tech note then specify exactly what
version of Unicode HFS+ is using to do its "normalization"?  Or
exactly what characters it will normalize?  After all, Unicode has
added all sorts of characters since 1998, and I'm sure some of them
were combining characters.

And you *really* want to continue argue that a sane thing for a
cross-platform system to do is to pervert its hash algorithm to take
into account *one* particular OS that happened to freeze a
normalization algorithm at some arbitrary point in time, approximately
nine years ago?  Talk about the tail wagging the dog!!  Especially
when you can't even justify why it was done nine years ago!

> It must have bought somebody something, or they never would have done it.

Your faith in the HFS+ designers is touching.

> I have no idea why HFS+ stores filenames in a normalized form, and further 
> I am smart enough to know that speculating is completely pointless. I 
> assume the authors had a good reason (which should be a safe assumption, 
> filesystem authors are a smart bunch). The reason may not be valid anymore, 
> but if it was valid back in 1998, then I can accept it without complaining.

Well, I *AM* a filesystem designer (ext2/ext3/ext4), and well before
1998, I knew that trying to do anything with Unicode normalization was
a fool's errand.  So if you're going to blindly trust filesystme
designers (not something I would recommend, actually :-), trust me.
What HFS+ is doing is dumb, dumb, dumb.

And even if *you* can accept it, why should the git designers pervert
any core part of git's design to support this behaviour?  Especially
if it's legacy behaviour which will hopefully be going away, say when
MacOS adopts ZFS --- there's an opportunity for them to start afresh,
and not make the same mistakes they made nine years ago!

So why don't you suggest some kind of sane fix in the Mac specific
code that doesn't impact any core part of git, such as its hash
algorithm?  It would be far more productive than trying to defend a
bad design decision made nine years ago....   :-}

					- Ted